/**************************************************************************//**
 * @file		core_cm0plus.h
 * @brief		CMSIS Cortex-M0+jӋ@\wͯ ̧
 * @version		V3.01
 * @date		2012N322
 *
 * @note
 * 쌠 (C) 2009-2012 ARM Limited. s
 *
 * @par
 * ARM Limited (ARM)Cortex-M۾ɊÂϲ ۰ׂŎgp邽߂ɂ̿ĳ
 * Ă܂B̧ق͂̂悤ARMɊÂ۾xJ°ٓ
 * Rɕz邱Ƃł܂B
 *
 * @par
 * ̿ĳ"󂻂̂܂"Œ񋟂܂Bۏ؁AI܂َ͖I܂͖@
 * Iǂ܂݂܂AɐꂸAړÎ߂̎sꐫƓK
 * ÖٓIȕۏ؂͂̿ĳɓKp܂BARM͉ꂩ̔@Ȃ闝RɂĂ
 * ̂悤ȏ󋵂łʓIAtIAhIQ̐ӔC𕉂܂B
 *
 ******************************************************************************/
#if defined ( __ICCARM__ )
 #pragma system_include		/* MISRAp ݸٰ ̧قƂĈ܂B */
#endif

#ifdef __cplusplus
 extern "C" {
#endif

#ifndef __CORE_CM0PLUS_H_GENERIC
#define __CORE_CM0PLUS_H_GENERIC

/** \page CMSIS_MISRA_Exceptions  MISRA-C:2004KO
  CMSIS͈ȉMISRA-C:2004KɈᔽ܂B

   \li KvƂK8.5, ͯ ̵̧ٓ޼ު/֐`<br>
     ͯ ̧ٓ̊֐`'inlining'̂Ɏgp܂B

   \li KvƂK18.4, p̌^̐錾܂͋p̌^̵޼ު: '{...}'.<br>
     p̂͊jڼ޽̗Lȕ\̂߂Ɏgp܂B

   \li K19.7, ֐lϸے`<br>
     ֐lϸۂ͂ƌIȺނ̂Ɏgp܂B
 */


/*******************************************************************************
 *                 CMSIS`
 ******************************************************************************/
/** \ingroup Cortex-M0+
  @{
 */

/*  CMSIS CM0P` */
#define __CM0PLUS_CMSIS_VERSION_MAIN	(0x03)									/*!< [31:16] CMSIS HAL */
#define __CM0PLUS_CMSIS_VERSION_SUB		(0x01)									/*!< [15:0]  CMSIS HAL */
#define __CM0PLUS_CMSIS_VERSION			((__CM0PLUS_CMSIS_VERSION_MAIN << 16) | \
										  __CM0PLUS_CMSIS_VERSION_SUB)			/*!< CMSIS HALŔԍ */

#define __CORTEX_M						(0x00)									/*!< Cortex-Mj */


#if   defined ( __CC_ARM )
  #define __ASM				__asm				/*!< ARM߲חpasmܰ */
  #define __INLINE			__inline			/*!< ARM߲חpinlineܰ */
  #define __STATIC_INLINE	static __inline

#elif defined ( __ICCARM__ )
  #define __ASM				__asm				/*!< IAR߲חpasmܰ */
  #define __INLINE			inline				/*!< IAR߲חpinlineܰށBœKłp\! */
  #define __STATIC_INLINE	static inline

#elif defined ( __GNUC__ )
  #define __ASM				__asm				/*!< GNU߲חpasmܰ */
  #define __INLINE			inline				/*!< GNU߲חpinlineܰ */
  #define __STATIC_INLINE	static inline

#elif defined ( __TASKING__ )
  #define __ASM				__asm				/*!< TASKING߲חpasmܰ */
  #define __INLINE			inline				/*!< TASKING߲חpinlineܰ */
  #define __STATIC_INLINE	static inline

#endif

/** __FPU_USEDFPUgp邩ۂ܂B̊j͑SĂFPUx܂B
*/
#define __FPU_USED       0

#if defined ( __CC_ARM )
  #if defined __TARGET_FPU_VFP
    #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
  #endif

#elif defined ( __ICCARM__ )
  #if defined __ARMVFP__
    #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
  #endif

#elif defined ( __GNUC__ )
  #if defined (__VFP_FP__) && !defined(__SOFTFP__)
    #warning "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
  #endif

#elif defined ( __TASKING__ )
  #if defined __FPU_VFP__
    #error "Compiler generates FPU instructions for a device without an FPU (check __FPU_PRESENT)"
  #endif
#endif

#include <stdint.h>			/* W^` */
#include <core_cmInstr.h>	/* j߱ */
#include <core_cmFunc.h>	/* j@\ */

#endif /* __CORE_CM0PLUS_H_GENERIC */

#ifndef __CMSIS_GENERIC

#ifndef __CORE_CM0PLUS_H_DEPENDANT
#define __CORE_CM0PLUS_H_DEPENDANT

/* ޲`Ɗgp */
#if defined __CHECK_DEVICE_DEFINES
  #ifndef __CM0PLUS_REV
    #define __CM0PLUS_REV             0x0000
    #warning "__CM0PLUS_REV not defined in device header file; using default!"
  #endif

  #ifndef __MPU_PRESENT
    #define __MPU_PRESENT             0
    #warning "__MPU_PRESENT not defined in device header file; using default!"
  #endif

  #ifndef __VTOR_PRESENT
    #define __VTOR_PRESENT            0
    #warning "__VTOR_PRESENT not defined in device header file; using default!"
  #endif

  #ifndef __NVIC_PRIO_BITS
    #define __NVIC_PRIO_BITS          2
    #warning "__NVIC_PRIO_BITS not defined in device header file; using default!"
  #endif

  #ifndef __Vendor_SysTickConfig
    #define __Vendor_SysTickConfig    0
    #warning "__Vendor_SysTickConfig not defined in device header file; using default!"
  #endif
#endif

/* I/O`(Ӌ@\ڼ޽ɑ΂鱸) */
/**
    \defgroup CMSIS_glob_defs CMSISS`

    <strong>I/O^Cq</strong>͈ȉɎgp܂B
    \li Ӌ@\ϐւ̱w
    \li Ӌ@\ڼ޽ ޯޏ̎
*/
#ifdef __cplusplus
  #define   __I     volatile		/*!< 'ǂݍݐp'` */
#else
  #define   __I     volatile const	/*!< 'ǂݍݐp'` */
#endif
#define     __O     volatile		/*!< 'ݐp'` */
#define     __IO    volatile		/*!< 'ǂݏp'` */

/*@} Cortex-M0+QI */


/*******************************************************************************
 *                 ڼ޽ۉ
  jڼ޽͈ȉ܂݂܂B:
  - jڼ޽
  - jNVICڼ޽
  - jSCBڼ޽
  - jSysTickڼ޽
  - jMPUڼ޽
 ******************************************************************************/
/** \defgroup CMSIS_core_register `ƌ^`
    \brief Cortex-M۾ɊÂ޲p^`ƒ`
*/

/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_CORE ԂƐڼ޽
    \brief    jڼ޽^`
  @{
 */

/** \brief p۸яڼ޽(APSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
#if (__CORTEX_M != 0x04)
		uint32_t _reserved0:27;				/*!< ޯ 0`26: \ */
#else
		uint32_t _reserved0:16;				/*!< ޯ 0`15: \ */
		uint32_t GE:4;						/*!< ޯ16`19: ȏ׸ */
		uint32_t _reserved1:7;				/*!< ޯ20`26: \ */
#endif
		uint32_t Q:1;						/*!< ޯ    27: Oa׸ */
		uint32_t V:1;						/*!< ޯ    28: Ժ ׸ */
		uint32_t C:1;						/*!< ޯ    29: ذԺ ׸ */
		uint32_t Z:1;						/*!< ޯ    30: ۏԺ ׸ */
		uint32_t N:1;						/*!< ޯ    31: Ժ ׸ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} APSR_Type;


/** \brief 荞۸яڼ޽(IPSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t ISR:9;						/*!< ޯ 0` 8: Oԍ */
		uint32_t _reserved0:23;				/*!< ޯ 9`31: \ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} IPSR_Type;


/** \brief ړI۸яڼ޽(xPSR)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t ISR:9;						/*!< ޯ 0` 8: Oԍ */
#if (__CORTEX_M != 0x04)
		uint32_t _reserved0:15;				/*!< ޯ 9`23: \ */
#else
		uint32_t _reserved0:7;				/*!< ޯ 9`15: \ */
		uint32_t GE:4;						/*!< ޯ16`19: ȏ׸ */
		uint32_t _reserved1:4;				/*!< ޯ20`23: \ */
#endif
		uint32_t T:1;						/*!< ޯ    24:  ޯ(0ǂ) */
		uint32_t IT:2;						/*!< ޯ25`26: ۑꂽIT(0ǂ) */
		uint32_t Q:1;						/*!< ޯ    27: Oa׸ */
		uint32_t V:1;						/*!< ޯ    28: Ժ ׸ */
		uint32_t C:1;						/*!< ޯ    29: ذԺ ׸ */
		uint32_t Z:1;						/*!< ޯ    30: ۏԺ ׸ */
		uint32_t N:1;						/*!< ޯ    31: Ժ ׸ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} xPSR_Type;


/** \brief ڼ޽(CONTROL)𱸾邽߂̋p̌^
 */
typedef union
{
	struct
	{
		uint32_t nPRIV:1;					/*!< ޯ     0: گޓł̗O */
		uint32_t SPSEL:1;					/*!< ޯ     1: gp */
		uint32_t FPCA:1;					/*!< ޯ     2: FPg׸ */
		uint32_t _reserved0:29;				/*!< ޯ 3`31: \ */
	} b;									/*!< ޯ Ɏgp\ */
	uint32_t w;								/*!< 걸Ɏgp^ */
} CONTROL_Type;

/*@} CMSIS_COREQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_NVIC q޸^荞ݐ(NVIC)
    \brief    NVICڼ޽p^`
  @{
 */

/** \brief q޸^荞ݐ(NVIC)𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t ISER[1];					/*!< ψ: 0x000 (R/W) 荞ݐݒ苖ڼ޽ */
		 uint32_t RESERVED0[31];
	__IO uint32_t ICER[1];					/*!< ψ: 0x080 (R/W) 荞݉ڼ޽ */
		 uint32_t RSERVED1[31];
	__IO uint32_t ISPR[1];					/*!< ψ: 0x100 (R/W) 荞ݐݒۗڼ޽ */
		 uint32_t RESERVED2[31];
	__IO uint32_t ICPR[1];					/*!< ψ: 0x180 (R/W) 荞݉ۗڼ޽ */
		 uint32_t RESERVED3[31];
		 uint32_t RESERVED4[64];
	__IO uint32_t IP[8];					/*!< ψ: 0x300 (R/W) 荞ݗD挠ڼ޽ */
}  NVIC_Type;

/*@} CMSIS_NVICQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_SCB ѐ䕔(SCB)
    \brief    ѐ䕔ڼ޽p^`
  @{
 */

/** \brief ѐ䕔(SCB)𱸾邽߂̍\̌^
 */
typedef struct
{
	__I  uint32_t CPUID;					/*!< ψ: 0x000 (R/ ) CPUIDڼ޽ */
	__IO uint32_t ICSR;						/*!< ψ: 0x004 (R/W) 荞ݐ/ڼ޽ */
#if (__VTOR_PRESENT == 1)
	__IO uint32_t VTOR;						/*!< ψ: 0x008 (R/W) ޸\ψڼ޽ */
#else
		 uint32_t RESERVED0;
#endif
	__IO uint32_t AIRCR;					/*!< ψ: 0x00C (R/W) p荞݂ؾĐڼ޽ */
	__IO uint32_t SCR;						/*!< ψ: 0x010 (R/W) ѐڼ޽ */
	__IO uint32_t CCR;						/*!< ψ: 0x014 (R/W) `Ԑݒ萧ڼ޽ */
		 uint32_t RESERVED1;
	__IO uint32_t SHP[2];					/*!< ψ: 0x01C (R/W) яD挠ڼ޽([0]͗\ς) */
	__IO uint32_t SHCSR;					/*!< ψ: 0x024 (R/W) я/ڼ޽ */
} SCB_Type;

/* SCB CPUIDڼ޽` */
#define SCB_CPUID_IMPLEMENTER_Pos			24											/*!< SCB CPUID: IMPLEMENTERʒu */
#define SCB_CPUID_IMPLEMENTER_Msk			(0xFFUL << SCB_CPUID_IMPLEMENTER_Pos)		/*!< SCB CPUID: IMPLEMENTERՕ */

#define SCB_CPUID_VARIANT_Pos				20											/*!< SCB CPUID: VARIANTʒu */
#define SCB_CPUID_VARIANT_Msk				(0xFUL << SCB_CPUID_VARIANT_Pos)			/*!< SCB CPUID: VARIANTՕ */

#define SCB_CPUID_ARCHITECTURE_Pos			16											/*!< SCB CPUID: ARCHITECTUREʒu */
#define SCB_CPUID_ARCHITECTURE_Msk			(0xFUL << SCB_CPUID_ARCHITECTURE_Pos)		/*!< SCB CPUID: ARCHITECTUREՕ */

#define SCB_CPUID_PARTNO_Pos				4											/*!< SCB CPUID: PARTNOʒu */
#define SCB_CPUID_PARTNO_Msk				(0xFFFUL << SCB_CPUID_PARTNO_Pos)			/*!< SCB CPUID: PARTNOՕ */

#define SCB_CPUID_REVISION_Pos				0											/*!< SCB CPUID: REVISIONʒu */
#define SCB_CPUID_REVISION_Msk				(0xFUL << SCB_CPUID_REVISION_Pos)			/*!< SCB CPUID: REVISIONՕ */

/* SCB Interrupt Control State Register Definitions */
#define SCB_ICSR_NMIPENDSET_Pos				31											/*!< SCB ICSR: NMIPENDSETʒu */
#define SCB_ICSR_NMIPENDSET_Msk				(1UL << SCB_ICSR_NMIPENDSET_Pos)			/*!< SCB ICSR: NMIPENDSETՕ */

#define SCB_ICSR_PENDSVSET_Pos				28											/*!< SCB ICSR: PENDSVSETʒu */
#define SCB_ICSR_PENDSVSET_Msk				(1UL << SCB_ICSR_PENDSVSET_Pos)				/*!< SCB ICSR: PENDSVSETՕ */

#define SCB_ICSR_PENDSVCLR_Pos				27											/*!< SCB ICSR: PENDSVCLRʒu */
#define SCB_ICSR_PENDSVCLR_Msk				(1UL << SCB_ICSR_PENDSVCLR_Pos)				/*!< SCB ICSR: PENDSVCLRՕ */

#define SCB_ICSR_PENDSTSET_Pos				26											/*!< SCB ICSR: PENDSTSETʒu */
#define SCB_ICSR_PENDSTSET_Msk				(1UL << SCB_ICSR_PENDSTSET_Pos)				/*!< SCB ICSR: PENDSTSETՕ */

#define SCB_ICSR_PENDSTCLR_Pos				25											/*!< SCB ICSR: PENDSTCLRʒu */
#define SCB_ICSR_PENDSTCLR_Msk				(1UL << SCB_ICSR_PENDSTCLR_Pos)				/*!< SCB ICSR: PENDSTCLRՕ */

#define SCB_ICSR_ISRPREEMPT_Pos				23											/*!< SCB ICSR: ISRPREEMPTʒu */
#define SCB_ICSR_ISRPREEMPT_Msk				(1UL << SCB_ICSR_ISRPREEMPT_Pos)			/*!< SCB ICSR: ISRPREEMPTՕ */

#define SCB_ICSR_ISRPENDING_Pos				22											/*!< SCB ICSR: ISRPENDINGʒu */
#define SCB_ICSR_ISRPENDING_Msk				(1UL << SCB_ICSR_ISRPENDING_Pos)			/*!< SCB ICSR: ISRPENDINGՕ */

#define SCB_ICSR_VECTPENDING_Pos			12											/*!< SCB ICSR: VECTPENDINGʒu */
#define SCB_ICSR_VECTPENDING_Msk			(0x1FFUL << SCB_ICSR_VECTPENDING_Pos)		/*!< SCB ICSR: VECTPENDINGՕ */

#define SCB_ICSR_VECTACTIVE_Pos				0											/*!< SCB ICSR: VECTACTIVEʒu */
#define SCB_ICSR_VECTACTIVE_Msk				(0x1FFUL << SCB_ICSR_VECTACTIVE_Pos)		/*!< SCB ICSR: VECTACTIVEՕ */

#if (__VTOR_PRESENT == 1)
/* SCB 荞ݐڼ޽` */
#define SCB_VTOR_TBLOFF_Pos					7											/*!< SCB VTOR: TBLOFFʒu */
#define SCB_VTOR_TBLOFF_Msk					(0x1FFFFFFUL << SCB_VTOR_TBLOFF_Pos)		/*!< SCB VTOR: TBLOFFՕ */
#endif

/* SCB p荞݂ؾĐڼ޽` */
#define SCB_AIRCR_VECTKEY_Pos				16											/*!< SCB AIRCR: VECTKEYʒu */
#define SCB_AIRCR_VECTKEY_Msk				(0xFFFFUL << SCB_AIRCR_VECTKEY_Pos)			/*!< SCB AIRCR: VECTKEYՕ */

#define SCB_AIRCR_VECTKEYSTAT_Pos			16											/*!< SCB AIRCR: VECTKEYSTATʒu */
#define SCB_AIRCR_VECTKEYSTAT_Msk			(0xFFFFUL << SCB_AIRCR_VECTKEYSTAT_Pos)		/*!< SCB AIRCR: VECTKEYSTATՕ */

#define SCB_AIRCR_ENDIANESS_Pos				15											/*!< SCB AIRCR: ENDIANESSʒu */
#define SCB_AIRCR_ENDIANESS_Msk				(1UL << SCB_AIRCR_ENDIANESS_Pos)			/*!< SCB AIRCR: ENDIANESSՕ */

#define SCB_AIRCR_SYSRESETREQ_Pos			2											/*!< SCB AIRCR: SYSRESETREQʒu */
#define SCB_AIRCR_SYSRESETREQ_Msk			(1UL << SCB_AIRCR_SYSRESETREQ_Pos)			/*!< SCB AIRCR: SYSRESETREQՕ */

#define SCB_AIRCR_VECTCLRACTIVE_Pos			1											/*!< SCB AIRCR: VECTCLRACTIVEʒu */
#define SCB_AIRCR_VECTCLRACTIVE_Msk			(1UL << SCB_AIRCR_VECTCLRACTIVE_Pos)		/*!< SCB AIRCR: VECTCLRACTIVEՕ */

/* SCB ѐڼ޽` */
#define SCB_SCR_SEVONPEND_Pos				4											/*!< SCB SCR: SEVONPENDʒu */
#define SCB_SCR_SEVONPEND_Msk				(1UL << SCB_SCR_SEVONPEND_Pos)				/*!< SCB SCR: SEVONPENDՕ */

#define SCB_SCR_SLEEPDEEP_Pos				2											/*!< SCB SCR: SLEEPDEEPʒu */
#define SCB_SCR_SLEEPDEEP_Msk				(1UL << SCB_SCR_SLEEPDEEP_Pos)				/*!< SCB SCR: SLEEPDEEPՕ */

#define SCB_SCR_SLEEPONEXIT_Pos				1											/*!< SCB SCR: SLEEPONEXITʒu */
#define SCB_SCR_SLEEPONEXIT_Msk				(1UL << SCB_SCR_SLEEPONEXIT_Pos)			/*!< SCB SCR: SLEEPONEXITՕ */

/* SCB `Ԑݒ萧ڼ޽` */
#define SCB_CCR_STKALIGN_Pos				9											/*!< SCB CCR: STKALIGNʒu */
#define SCB_CCR_STKALIGN_Msk				(1UL << SCB_CCR_STKALIGN_Pos)				/*!< SCB CCR: STKALIGNՕ */

#define SCB_CCR_UNALIGN_TRP_Pos				3											/*!< SCB CCR: UNALIGN_TRPʒu */
#define SCB_CCR_UNALIGN_TRP_Msk				(1UL << SCB_CCR_UNALIGN_TRP_Pos)			/*!< SCB CCR: UNALIGN_TRPՕ */

/* SCB я/ڼ޽` */
#define SCB_SHCSR_SVCALLPENDED_Pos			15											/*!< SCB SHCSR: SVCALLPENDEDʒu */
#define SCB_SHCSR_SVCALLPENDED_Msk			(1UL << SCB_SHCSR_SVCALLPENDED_Pos)			/*!< SCB SHCSR: SVCALLPENDEDՕ */

/*@} CMSIS_SCBQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_SysTick эv(SysTick)
    \brief    эvp^`
  @{
 */

/** \brief э(SysTick)𱸾邽߂̍\̌^
 */
typedef struct
{
	__IO uint32_t CTRL;						/*!< ψ: 0x000 (R/W) SysTick/ڼ޽ */
	__IO uint32_t LOAD;						/*!< ψ: 0x004 (R/W) SysTickĐݒlڼ޽ */
	__IO uint32_t VAL;						/*!< ψ: 0x008 (R/W) SysTickݒlڼ޽ */
	__I  uint32_t CALIB;					/*!< ψ: 0x00C (R/ ) SysTickZڼ޽ */
} SysTick_Type;

/* SysTick /ڼ޽` */
#define SysTick_CTRL_COUNTFLAG_Pos			16											/*!< SysTick CTRL: COUNTFLAGʒu */
#define SysTick_CTRL_COUNTFLAG_Msk			(1UL << SysTick_CTRL_COUNTFLAG_Pos)			/*!< SysTick CTRL: COUNTFLAGՕ */

#define SysTick_CTRL_CLKSOURCE_Pos			2											/*!< SysTick CTRL: CLKSOURCEʒu */
#define SysTick_CTRL_CLKSOURCE_Msk			(1UL << SysTick_CTRL_CLKSOURCE_Pos)			/*!< SysTick CTRL: CLKSOURCEՕ */

#define SysTick_CTRL_TICKINT_Pos			1											/*!< SysTick CTRL: TICKINTʒu */
#define SysTick_CTRL_TICKINT_Msk			(1UL << SysTick_CTRL_TICKINT_Pos)			/*!< SysTick CTRL: TICKINTՕ */

#define SysTick_CTRL_ENABLE_Pos				0											/*!< SysTick CTRL: ENABLEʒu */
#define SysTick_CTRL_ENABLE_Msk				(1UL << SysTick_CTRL_ENABLE_Pos)			/*!< SysTick CTRL: ENABLEՕ */

/* SysTick Đݒlڼ޽` */
#define SysTick_LOAD_RELOAD_Pos				0											/*!< SysTick LOAD: RELOADʒu */
#define SysTick_LOAD_RELOAD_Msk				(0xFFFFFFUL << SysTick_LOAD_RELOAD_Pos)		/*!< SysTick LOAD: RELOADՕ */

/* SysTick ݒlڼ޽` */
#define SysTick_VAL_CURRENT_Pos				0											/*!< SysTick VAL: CURRENTʒu */
#define SysTick_VAL_CURRENT_Msk				(0xFFFFFFUL << SysTick_VAL_CURRENT_Pos)		/*!< SysTick VAL: CURRENTՕ */

/* SysTick Zڼ޽` */
#define SysTick_CALIB_NOREF_Pos				31											/*!< SysTick CALIB: NOREFʒu */
#define SysTick_CALIB_NOREF_Msk				(1UL << SysTick_CALIB_NOREF_Pos)			/*!< SysTick CALIB: NOREFՕ */

#define SysTick_CALIB_SKEW_Pos				30											/*!< SysTick CALIB: SKEWʒu */
#define SysTick_CALIB_SKEW_Msk				(1UL << SysTick_CALIB_SKEW_Pos)				/*!< SysTick CALIB: SKEWՕ */

#define SysTick_CALIB_TENMS_Pos				0											/*!< SysTick CALIB: TENMSʒu */
#define SysTick_CALIB_TENMS_Msk				(0xFFFFFFUL << SysTick_VAL_CURRENT_Pos)		/*!< SysTick CALIB: TENMSՕ */

/*@} CMSIS_SysTickQI */

#if (__MPU_PRESENT == 1)
/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_MPU ؕی암(MPU)
    \brief    ؕی암(MPU)p^`
  @{
 */

/** \brief ؕی암(MPU)𱸾邽߂̍\̌^
 */
typedef struct
{
	__I  uint32_t TYPE;						/*!< ψ: 0x000 (R/ )  MPU `ڼ޽ */
	__IO uint32_t CTRL;						/*!< ψ: 0x004 (R/W)  MPU ڼ޽ */
	__IO uint32_t RNR; 						/*!< ψ: 0x008 (R/W)  MPU ̈RNRberڼ޽ */
	__IO uint32_t RBAR;						/*!< ψ: 0x00C (R/W)  MPU ̈ڽ ڼ޽ */
	__IO uint32_t RASR;						/*!< ψ: 0x010 (R/W)  MPU ̈摮/eڼ޽ */
} MPU_Type;

/* MPU `ڼ޽ */
#define MPU_TYPE_IREGION_Pos				16   										/*!< MPU TYPE: IREGIONʒu */
#define MPU_TYPE_IREGION_Msk				(0xFFUL << MPU_TYPE_IREGION_Pos)			/*!< MPU TYPE: IREGIONՕ */

#define MPU_TYPE_DREGION_Pos				8   										/*!< MPU TYPE: DREGIONʒu */
#define MPU_TYPE_DREGION_Msk				(0xFFUL << MPU_TYPE_DREGION_Pos)			/*!< MPU TYPE: DREGIONՕ */

#define MPU_TYPE_SEPARATE_Pos				0   										/*!< MPU TYPE: SEPARATEʒu */
#define MPU_TYPE_SEPARATE_Msk				(1UL << MPU_TYPE_SEPARATE_Pos)				/*!< MPU TYPE: SEPARATEՕ */

/* MPU ڼ޽ */
#define MPU_CTRL_PRIVDEFENA_Pos				2   										/*!< MPU CTRL: PRIVDEFENAʒu */
#define MPU_CTRL_PRIVDEFENA_Msk				(1UL << MPU_CTRL_PRIVDEFENA_Pos)			/*!< MPU CTRL: PRIVDEFENAՕ */

#define MPU_CTRL_HFNMIENA_Pos				1   										/*!< MPU CTRL: HFNMIENAʒu */
#define MPU_CTRL_HFNMIENA_Msk				(1UL << MPU_CTRL_HFNMIENA_Pos)				/*!< MPU CTRL: HFNMIENAՕ */

#define MPU_CTRL_ENABLE_Pos					0   										/*!< MPU CTRL: ENABLEʒu */
#define MPU_CTRL_ENABLE_Msk					(1UL << MPU_CTRL_ENABLE_Pos)				/*!< MPU CTRL: ENABLEՕ */

/* MPU ̈ԍڼ޽ */
#define MPU_RNR_REGION_Pos					0   										/*!< MPU RNR: REGIONʒu */
#define MPU_RNR_REGION_Msk					(0xFFUL << MPU_RNR_REGION_Pos)				/*!< MPU RNR: REGIONՕ */

/* MPU ̈ڽ ڼ޽ */
#define MPU_RBAR_ADDR_Pos					8   										/*!< MPU RBAR: ADDRʒu */
#define MPU_RBAR_ADDR_Msk					(0xFFFFFFFUL << MPU_RBAR_ADDR_Pos)			/*!< MPU RBAR: ADDRՕ */

#define MPU_RBAR_VALID_Pos					4   										/*!< MPU RBAR: VALIDʒu */
#define MPU_RBAR_VALID_Msk					(1UL << MPU_RBAR_VALID_Pos)					/*!< MPU RBAR: VALIDՕ */

#define MPU_RBAR_REGION_Pos					0   										/*!< MPU RBAR: REGIONʒu */
#define MPU_RBAR_REGION_Msk					(0xFUL << MPU_RBAR_REGION_Pos)				/*!< MPU RBAR: REGIONՕ */

/* MPU ̈摮/eڼ޽ */
#define MPU_RASR_ATTRS_Pos					16   										/*!< MPU RASR: MPU ̈摮̈ʒu */
#define MPU_RASR_ATTRS_Msk					(0xFFFFUL << MPU_RASR_ATTRS_Pos)			/*!< MPU RASR: MPU ̈摮̈Օ */

#define MPU_RASR_XN_Pos						28											/*!< MPU RASR: ATTRS.XNʒu */
#define MPU_RASR_XN_Msk						(1UL << MPU_RASR_XN_Pos)					/*!< MPU RASR: ATTRS.XNՕ */

#define MPU_RASR_AP_Pos						24											/*!< MPU RASR: ATTRS.APʒu */
#define MPU_RASR_AP_Msk						(0x7UL << MPU_RASR_AP_Pos)					/*!< MPU RASR: ATTRS.APՕ */

#define MPU_RASR_TEX_Pos					19											/*!< MPU RASR: ATTRS.TEXʒu */
#define MPU_RASR_TEX_Msk					(0x7UL << MPU_RASR_TEX_Pos)					/*!< MPU RASR: ATTRS.TEXՕ */

#define MPU_RASR_S_Pos						18											/*!< MPU RASR: ATTRS.Sʒu */
#define MPU_RASR_S_Msk						(1UL << MPU_RASR_S_Pos)						/*!< MPU RASR: ATTRS.SՕ */

#define MPU_RASR_C_Pos						17											/*!< MPU RASR: ATTRS.Cʒu */
#define MPU_RASR_C_Msk						(1UL << MPU_RASR_C_Pos)						/*!< MPU RASR: ATTRS.CՕ */

#define MPU_RASR_B_Pos						16											/*!< MPU RASR: ATTRS.Bʒu */
#define MPU_RASR_B_Msk						(1UL << MPU_RASR_B_Pos)						/*!< MPU RASR: ATTRS.BՕ */

#define MPU_RASR_SRD_Pos					8   										/*!< MPU RASR: ̈֎~ʒu */
#define MPU_RASR_SRD_Msk					(0xFFUL << MPU_RASR_SRD_Pos)				/*!< MPU RASR: ̈֎~Օ */

#define MPU_RASR_SIZE_Pos					1   										/*!< MPU RASR: ̈eʗ̈ʒu */
#define MPU_RASR_SIZE_Msk					(0x1FUL << MPU_RASR_SIZE_Pos)				/*!< MPU RASR: ̈eʗ̈Օ */

#define MPU_RASR_ENABLE_Pos					0   										/*!< MPU RASR: ̈拖ޯĈʒu */
#define MPU_RASR_ENABLE_Msk					(1UL << MPU_RASR_ENABLE_Pos)				/*!< MPU RASR: ̈拖ޯĎՕ */

/*@} CMSIS_MPUQI */
#endif


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_CoreDebug jޯ ڼ޽(CoreDebug)
    \brief    Cortex-M0+jޯ ڼ޽(DCBڼ޽ASHCSRADFSR)۾oRł
              ȂDAPł\łB]āACortex-M0ͯ ̧ق
              Ėԗ܂B
  @{
 */
/*@} CMSIS_CoreDebugQI */


/** \ingroup  CMSIS_core_register
    \defgroup CMSIS_core_base j`
    \brief    ڽAṕA\̗p`
  @{
 */

/* Cortex-M0+ʰ޳؊蓖 */
#define SCS_BASE		(0xE000E000UL)							/*!< ѐԊڽ */
#define SysTick_BASE	(SCS_BASE +  0x0010UL)					/*!< SysTickڽ */
#define NVIC_BASE		(SCS_BASE +  0x0100UL)					/*!< NVICڽ */
#define SCB_BASE		(SCS_BASE +  0x0D00UL)					/*!< ѐ䕔ڽ */

#define SCB				((SCB_Type       *)     SCB_BASE      )	/*!< SCB`Ԑݒ\ */
#define SysTick			((SysTick_Type   *)     SysTick_BASE  )	/*!< SysTick`Ԑݒ\ */
#define NVIC			((NVIC_Type      *)     NVIC_BASE     )	/*!< NVIC`Ԑݒ\ */

#if (__MPU_PRESENT == 1)
  #define MPU_BASE		(SCS_BASE +  0x0D90UL)					/*!< ؕی암 */
  #define MPU			((MPU_Type       *)     MPU_BASE      )	/*!< ؕی암 */
#endif

/*@} */


/*******************************************************************************
 *                ʰ޳ۑw
  j@\̪͈ȉ܂݂܂B:
  - jNVIC֐
  - jSysTick֐
  - jڼ޽ ֐
 ******************************************************************************/
/** \defgroup CMSIS_Core_FunctionInterface @\Ɩ߂̊
*/


/* ##########################   NVIC֐  #################################### */
/** \ingroup  CMSIS_Core_FunctionInterface
    \defgroup CMSIS_Core_NVICFunctions NVIC֐
    \brief    NVICoRŊ荞݂ƗOǗ֐
    @{
 */

/* 荞ݗD挠ARMv6MWORD()\łB */
/* ȉϸۂڼ޽ψʂ޲ĎՕ̐܂B */
#define _BIT_SHIFT(IRQn)	(  (((uint32_t)(IRQn)       )    &  0x03) * 8 )
#define _SHP_IDX(IRQn)		( ((((uint32_t)(IRQn) & 0x0F)-8) >>    2)     )
#define _IP_IDX(IRQn)		(   ((uint32_t)(IRQn)            >>    2)     )


/** \brief O荞݋

    ֐NVIC荞ݐ޲L荞݂܂B

    \param[in]  IRQn O荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_EnableIRQ(IRQn_Type IRQn)
{
	NVIC->ISER[0] = (1 << ((uint32_t)(IRQn) & 0x1F));
}

/** \brief O荞݋֎~

    ֐NVIC荞ݐ޲L荞݂֎~܂B

    \param[in]  IRQn O荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_DisableIRQ(IRQn_Type IRQn)
{
	NVIC->ICER[0] = (1 << ((uint32_t)(IRQn) & 0x1F));
}

/** \brief ۗ荞݂擾

    ֐NVICŕۗڼ޽ǂŎw肳ꂽ荞݂ɑ΂ۗޯĂԂ܂B

    \param[in]  IRQn 荞ݔԍ

    \return     0    荞݂̏Ԃ͕ۗłȂB
    \return     1    荞݂̏Ԃ͕ۗ
 */
__STATIC_INLINE uint32_t NVIC_GetPendingIRQ(IRQn_Type IRQn)
{
	return((uint32_t) ((NVIC->ISPR[0] & (1 << ((uint32_t)(IRQn) & 0x1F)))?1:0));
}

/** \brief ۗ荞ݐݒ

    ֐͊O荞݂ۗ̕ޯĂݒ肵܂B

    \param[in]  IRQn 荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_SetPendingIRQ(IRQn_Type IRQn)
{
	NVIC->ISPR[0] = (1 << ((uint32_t)(IRQn) & 0x1F));
}

/** \brief ۗ荞݉

    ֐͊O荞݂ۗ̕ޯĂ܂B

    \param[in]  IRQn 荞ݔԍBl͕ɂł܂B
 */
__STATIC_INLINE void NVIC_ClearPendingIRQ(IRQn_Type IRQn)
{
	NVIC->ICPR[0] = (1 << ((uint32_t)(IRQn) & 0x1F)); /* Clear pending interrupt */
}

/** \brief 荞ݗD挠ݒ

    ֐͊荞݂̗D挠ݒ肵܂B

    \note D挠͑SĂ̊j荞݂ɑ΂Đݒłł͂܂B

    \param[in]  IRQn     荞ݔԍ
    \param[in]  priority ݒ肷D挠
 */
__STATIC_INLINE void NVIC_SetPriority(IRQn_Type IRQn, uint32_t priority)
{
	if(IRQn < 0) {
		SCB->SHP[_SHP_IDX(IRQn)] = (SCB->SHP[_SHP_IDX(IRQn)] & ~(0xFF << _BIT_SHIFT(IRQn))) |
			(((priority << (8 - __NVIC_PRIO_BITS)) & 0xFF) << _BIT_SHIFT(IRQn)); }
	else {
		NVIC->IP[_IP_IDX(IRQn)] = (NVIC->IP[_IP_IDX(IRQn)] & ~(0xFF << _BIT_SHIFT(IRQn))) |
			(((priority << (8 - __NVIC_PRIO_BITS)) & 0xFF) << _BIT_SHIFT(IRQn)); }
}

/** \brief 荞ݗD挠擾

    ֐͊荞݂̗D挠ǂ݂܂B荞ݔԍ͊O(޲L)荞݂
    w肷̂ɐɁA(j)荞݂w肷̂ɕɂ邱Ƃł܂B

    \param[in]  IRQn ֒ݔԍ
    \return          荞ݗD挠Blϲ ۰ׂ̎ꂽD挠ޯĂɎ
                     Iɐ񂳂܂B
 */
__STATIC_INLINE uint32_t NVIC_GetPriority(IRQn_Type IRQn)
{

	if(IRQn < 0) {
		return((uint32_t)((SCB->SHP[_SHP_IDX(IRQn)] >> _BIT_SHIFT(IRQn) ) >> (8 - __NVIC_PRIO_BITS)));  }	/* Cortex-Mъ荞ݗpD挠擾 */
	else {
		return((uint32_t)((NVIC->IP[ _IP_IDX(IRQn)] >> _BIT_SHIFT(IRQn) ) >> (8 - __NVIC_PRIO_BITS)));  }	/* ޲L荞ݗpD挠擾 */
}

/** \brief  ؾ

    ֐MCUؾĂ邽߂ɼ ؾėvn߂܂B
 */
__STATIC_INLINE void NVIC_SystemReset(void)
{
	__DSB(); 												/* ؾđOɊɏՂꂽ݂܂ޑSĂ̖ ̂ۏ */
	SCB->AIRCR  = ((0x5FA << SCB_AIRCR_VECTKEY_Pos)      |
					SCB_AIRCR_SYSRESETREQ_Msk);
	__DSB();												/*  ̊ۏ */
	while(1);												/* ؾđ҂ */
}

/*@} CMSIS_Core_NVICFunctionsI */


/* ##################################    SysTick֐  ############################################ */
/** \ingroup  CMSIS_Core_FunctionInterface
    \defgroup CMSIS_Core_SysTickFunctions SysTick֐
    \brief    ь`Ԑݒ֐
  @{
 */

#if (__Vendor_SysTickConfig == 0)

/** \brief э`Ԑݒ

    ֐ͼьvƂ̊荞݂AэvJn܂Bv
    ͎IȊ荞݂𐶐邽߂ɎRsłB

    \param[in]  ticks 2̊荞݊Ԃ̍

    \return     0     ֐
    \return     1     ֐s

    \note <b>__Vendor_SysTickConfig</b>ϐ1ɐݒ肳ƁA<b>SysTick_Config
          </b>֐Ͳݸٰނ܂B̏ꍇA<b><i>device</i>.h</b>̧ق͂
          ̊֐̋ғL܂܂Ȃ΂Ȃ܂B

 */
__STATIC_INLINE uint32_t SysTick_Config(uint32_t ticks)
{
	if (ticks > SysTick_LOAD_RELOAD_Msk)  return (1);			/* Đݒls\ */

	SysTick->LOAD  = (ticks & SysTick_LOAD_RELOAD_Msk) - 1;		/* Đݒڼ޽ݒ */
	NVIC_SetPriority (SysTick_IRQn, (1<<__NVIC_PRIO_BITS) - 1);	/* Systick荞ݗpD挠ݒ */
	SysTick->VAL   = 0;											/* SysTickvlݒ */
	SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |
					 SysTick_CTRL_TICKINT_Msk   |
					 SysTick_CTRL_ENABLE_Msk;					/* SysTick荞݂SysTickv */
  return (0);													/* ֐ */
}

#endif

/*@} CMSIS_Core_SysTickFunctionsI */


#endif /* __CORE_CM0PLUS_H_DEPENDANT */

#endif /* __CMSIS_GENERIC */

#ifdef __cplusplus
}
#endif
